#version 130
#extension GL_EXT_gpu_shader4 : enable
// the version and open GL extension
// should be the first line of the shader
/////////////////////////////////////////////////////////////////////////////////
//Jelly fish remix2Mod01.fsh   by  DENFOR   
//https://www.shadertoy.com/view/mtK3WW
//Licence : Creative Commons Attribution-ShareAlike 4.0
//http://creativecommons.org/licences/by-sa/4.0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.628318  //314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform sampler2D texture3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

// Original shader from: https://bit.ly/2WoLdpT

/*#ifdef GL_ES
precision highp float;
#endif */
/*
uniform float time;
uniform vec2 resolution;  */

#define round(x) floor((x) + 0.5)

const float PI = 3.141592653589793;

mat2 rotate2D(float r){
    return mat2(cos(r), sin(r), -sin(r), cos(r));
}

vec3 hsv(float h, float s, float v){            // Head color  change
    vec4 t = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0*(1.+0.75*sin(iTime*0.2 )  ));
    vec3 p = abs(fract(vec3(h) + t.xyz) * 6.0 - vec3(t.w));
    return v * mix(vec3(t.x), clamp(p - vec3(t.x), 0.0, 1.0), s*0.9);
}

void twigl(out vec4 o, vec4 FC, vec2 r, float t) {
    o=vec4(0);
    float e=0.,g=0.,s;  
    for(float i=0.;i<1e2;i++){           // g scale factor 
                                               // vec2(x,y)offset //e; z axis position
        vec3 p=vec3((FC.xy-r*.5)/r.y*0.95 /**g */+vec2( 1.5*0.,0.00) ,g+=e);
        p.y-=t*.1;   // y axis move(up)
       //   p.x-=t*0.1 ; //p.z -=0.1*t*0. ; // x,z axis move
          
    //     p -=round(p) ; 
        p.y-=round(p.y);  //  p.x -=round(p.x) ;/* p.z -=round(p.z);*/
        p.zy *=rotate2D(iTime*PI*0.025) ;
        p.xy *=rotate2D(iTime*PI*0.015  );
        
        p.xz*=1.+sin(t*PI+(round(g)*0.+p.y)*9.)*.2;
        e=s=9.*0.5;
        for(int j=0;j<6;j++){
          //  e=s/2e6+min(e,max(-p.y,abs(length(p)-.2*1.3))/s),p.y+=length(p.xz)*2.,p=.2-abs(p*3.);
           e=s/2e6+min(e*0.95,max(-p.y+0.035,abs(length(p)-.2*1.3))/s) ,
             p.y+=length(p.xz)*2.*.75,
           p=.2-abs(p*3.*0.85-vec3(0,2e-3/dot(p.xz,p.xz),0)*0.5  /**(1.+0.15*abs(sin(iTime*0.15))  ) */);
           
           s+=s;
        }
        o.rgb+=hsv(.6+.9/p.y,.9,4e-6/e);
    }
}

//void mainImage( out vec4 fragColor, in vec2 fragCoord )
///////////////////////////////////////////////////////////////////////////////// 
// need to convert this from a void to a function and call it by adding
// a void main(void) { to the end of the shader
// what type of variable will the function return?, it is a color and needs to be a vec4
// change void to vec4 
//void MainImage(out vec4 fragColor, in vec2 fragCoord) 
vec4 mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    vec4 o =vec4(0); vec4 FC ;  FC.xy = fragCoord ;
    /* vec3 resolution =iResolution ;*/  float time =iTime ;

 //    twigl(o ,FC, /*iResolution*/resolution.xy, time);
      twigl(o ,FC, iResolution.xy, time);
   //  twigl(o ,FC, iResolution, time);  
  
    fragColor =vec4( o.rgb, 1.0 ) ;
/////////////////////////////////////////////////////////////////////////////////
//the function needs to return a value. 
//it needs to be a vec4
//we will return the varable fragColor 
// usual place for fragColor = vec4( color, 1.0 ); bring the } down below
return fragColor; 
}

///////////////////////////////////////////////////////////////////////////////// 
void main(void) { // this will be run for every pixel of gl_FragCoord.xy
vec4 vTexCoord = gl_TexCoord[0];
vec4 fragColor = vec4(1.0); // initialize variable fragColor as a vec4 
vec4 cc = mainImage(fragColor, gl_FragCoord.xy); // call function mainImage and assign the return vec4 to cc
gl_FragColor = vec4(cc) * gl_Color; // set the pixel to the value of vec4 cc  and..
//gl_FragColor.a = length(gl_FragColor.rgb);
}

// ..uses the values of any Color: or Opacity:
// clauses (and any Animate clauses applied to these properties) 
// appearing in the Sprite, Quad or other node invoking the shader 
// in the .scn file.

